#include <fstream.h>
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//#define DEBUG
//#define FULLDEBUG

#define AMINOAM 20
#define MAXAMINOCODES 7

char aminocodes[AMINOAM][MAXAMINOCODES][4];
int aminocodeam[AMINOAM];
char *data; 
int datasize = 0; 
int datalen = 0;
int outputaminos;

int readcodes(char *filename);

void main(int argc, char **argv) {
  int i;

  if (argc<2) {
    cout << "Arguments: <filename> <step (default 0)> <output aminos (default 0)>"<<endl;
    exit(-1);
  }

  readcodes("aminocodes.txt");

  ifstream infs;
  char line[1024];
  int step=0;
  if (argc>2)
    step = atoi(argv[2]);

  if (argc>3)
    outputaminos = atoi(argv[3]);
  
  int counter=0;
  
  char *datafile = new char[strlen(argv[1]+10)];
  char *resultfile = new char[strlen(argv[1]+10)];
  sprintf(datafile,"%sdata",argv[1]);
  sprintf(resultfile,"%scorrect",argv[1]);

  infs.open(datafile);
  if (infs.peek()==EOF) {
    cout << "Error, unable to open data file "<<datafile<<endl;
    exit(-1);
  }

  cout << "Reading data..."<<endl;
  
  while(infs.peek()!=EOF) {
    infs.getline(line,1024);
    datasize += strlen(line);
  }
  
  data = new char[datasize+1];
  cout << "\tThere are "<<datasize<<" items in "<<datafile<<"..."<<endl;

  infs.close();
  infs.open(datafile);

  while (infs.peek()!=EOF) {  // read data 
    infs.getline(line,1024);
    strcpy(&data[datalen],line);
    if (datalen + strlen(line)>datasize) {
      char *newdata = new char[2*datasize];
      char *olddata = data;
      strcpy(newdata,olddata);
      delete olddata;
      data = newdata;
      datasize = 2*datasize;
#ifdef DEBUG
      cout << "###resizing data to "<<2*datasize<<"...."<<endl;
#endif
    }
#ifdef FULLDEBUG
    cout << "###data (length = "<<datalen<<") = "<<data<<endl;
#endif
    datalen = datalen+strlen(line);
    }
  infs.close();
#ifdef DEBUG
  cout << "### data (length = "<<datalen<<") = "<<data<<endl;
#endif
  cout << "\tread "<<datalen<<" items"<<endl;

  infs.open(resultfile);
  if (infs.peek()==EOF) {
    cout << "Error, unable to open result file "<<resultfile<<endl;
    exit(-1);
  }

  cout << "Reading correct results..."<<endl;
  
  int resam=0;
  char tester;
  int incodon = 0;
  int maxcodonlen = 0;
  int thiscodonlen = 0;

  while(infs.peek()!=EOF) {
    infs.get(tester);
    if (tester=='#') {
      infs.getline(line,1024);
      incodon = 1;      
      thiscodonlen = 0;
    }
    if (tester==':') {
      resam++;
      incodon = 0;
      if (thiscodonlen>maxcodonlen) maxcodonlen = thiscodonlen;
    }
    if (incodon) thiscodonlen ++;
    
  }
  
  cout << "\t" << resam << " correct codon regions are in the data"<<endl;

  char **codons = new char*[resam];
  for (int cht=0;cht<resam;cht++)
    codons[cht] = new char[maxcodonlen];
  int codonstarts[resam];
  int codonstops[resam];
  int codonam = resam;
  
  infs.close();
  infs.open(resultfile);

  resam = 0;
  int tpos = 0;
  while(infs.peek()!=EOF) {
    infs.get(tester);
    if (infs.peek()==EOF) break;
    if (tester=='#') {
      tpos = 0;
      infs.getline(line,1024);
      sscanf(line,"%d %d",&codonstarts[resam],&codonstops[resam]);
      codonstarts[resam]-=2; 
      codonstops[resam];
    } else if (tester==':') {
#ifdef DEBUG
      cout << "### read codon "<<codonstarts[resam]<<"-"<<codonstops[resam]<<": "<<codons[resam]<<endl;
#endif
      resam++;
    } else if (tester!='\n') {
      codons[resam][tpos] = tester;
      tpos++;
    }
  }

  infs.close();
  
  cout << "Starting predictions for step "<<step<<"..."<<endl;

  /*
    The output is in the form usable by the Committee structures previosly designed, namely:
 
    <line> <NameA> <NameB> <correct label> <1st result> <1st distance> <1st proto> <2nd result> <2nd distance> <2nd proto>               
  */


  ofstream outfs;
  char outname[1024];
  sprintf(outname,"preda%d%d.out",outputaminos,step);
  outfs.open(outname);
  for (int s=step;s<datalen;s+=3) {
#ifdef DEBUG
    cout << "position "<<s<<" (";
    for (int ttt=0;ttt<3;ttt++)
      cout << data[s+ttt] ;
    cout << ") matches: "<<flush;
#endif    
    outfs << counter*3 << " foo foo ";

    int incodon = 0;
    for (int crs=0;crs<codonam;crs++) 
      if ((s-step) > codonstarts[crs] && (s-step) < codonstops[crs]) incodon = crs+1;
    
    if (incodon) {
      //      if (outputaminos) 
      //	outfs << codons[incodon-1][(s-codonstarts[incodon-1])/3] << " " <<flush;
      //    else
	outfs << "c " << flush;
    }
    else outfs << "n " << flush;
    int wasmatched = 0;
    for (int i=0;i<AMINOAM;i++)
      for (int j=1;j<aminocodeam[i];j++) { 
	int matches = 0;
	for (int k=0;k<3;k++) {
	  if (data[s+k]==aminocodes[i][j][k]) matches ++;
	  //	    cout << data[s+step+k] <<" vs "<<aminocodes[i][j][k]<<endl;
	}
	if (matches==3) {
#ifdef DEBUG
	  cout << aminocodes[i][0] << " " << flush;
#endif      
	  if (outputaminos)
	    outfs << aminocodes[i][0] << " 0 0 n 0 0"<<endl;
	  else 
	    outfs << "c 0 0 n 0 0"<<endl;
	  wasmatched = 1;
	}
      }
    
    if (!wasmatched) 
      if (outputaminos)
	outfs << "n 0 0 n 0 0"<<endl;   
      else
	outfs << "n 0 0 c 0 0"<<endl;   
    
#ifdef DEBUG
    cout << endl;
#endif      
    counter ++;
  }
  outfs << endl;
  outfs.close();
  cout << "Done! Results are in "<<outname<<endl;
}

int readcodes(char *filename) {
#ifdef DEBUG
  cout << "### readcodes("<<filename<<")"<<endl;
#endif
  ifstream infs;
  infs.open(filename);
  if (infs.peek()==EOF) {
    cout << "Error, unable to open amino code file '"<<filename<<"'!!!"<<endl;
    exit(-1);
  }
  char line[1024];
  int counter=0;
  while (infs.peek()!=EOF) {
    if (counter>AMINOAM) {
      cout << "Error, exeeded maximum amino code amount of "<<AMINOAM<<endl;
      exit(-1);
    }
    infs.getline(line,1024);
    if (!strlen(line)) break;
    //    char aminocodes[AMINOAM][MAXAMINOCODES][3];    
    aminocodes[counter][0][0] = line[0];
    aminocodes[counter][0][1] = '\0';
    int p=2;
    for (int i=1;i<MAXAMINOCODES;i++) {
      int j=0;
      while(p<strlen(line)) {
#ifdef FULLDEBUG
	cout << "line[p] = "<<line[p]<<", aminocodes["<<counter<<"]["<<i<<"] = "<<aminocodes[counter][i]<<endl;
#endif
	if (line[p]!=' ') 
	  aminocodes[counter][i][j] = line[p];	
	else {
	  p++;
	  j = 99999;
#ifdef FULLDEBUG
	  cout << "break!"<<endl;
#endif
	  break;
	}
	j++;
	p++;
	aminocodeam[counter]=i+1;
      }
      aminocodes[counter][i][4] = '\0';	
    }
#ifdef DEBUG
    cout << "###\tread aminocode: ";
    for (int q=0;q<aminocodeam[counter];q++)
      cout << aminocodes[counter][q] << " ";
    cout << "("<<aminocodeam[counter]<<")";
   cout << endl;
#endif
    counter ++;
  }
#ifdef DEBUG
  cout << "### readcodes done!"<<endl;
#endif
  return counter;
}
