#include <fstream.h>
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//#define DEBUG
//#define FULLDEBUG

int *data = new int[10000];
char *correct = new char[10000];
int *indexes = new int[10000];
int datasize = 10000;
int datalen = 0;

int readcodes(char *filename);

void main(int argc, char **argv) {
  int i,j;

  if (argc<2) {
    cout << "Arguments: <filename> <evalrange (default 50)> <allowed nonaminos (default evalrange/10)>"<<endl;
    exit(-1);
  }

  ifstream infs;
  infs.open(argv[1]);

  int evalrange = 50;
  if (argc>2)
    evalrange = atoi(argv[2]);

  int allowed = evalrange/10;
  if (argc>3)
    allowed = atoi(argv[3]);
  

  if (infs.peek()==EOF) {
    cout << "Error, unable to open data file "<<argv[1]<<endl;
    exit(-1);
  }
  
  cout << "Reading data..."<<endl;
  char foo[1024];
  char resa;
  char line[1024];
  while (infs.peek()!=EOF) {  // read data 
    infs.getline(line,1024);
    if (datalen > datasize-2) {
      int *newdata = new int[2*datasize];
      int *olddata = data;
      char *newcorrect = new char[2*datasize];
      char *oldcorrect = correct;
      int *newindexes = new int[2*datasize];
      int *oldindexes = indexes;
      strcpy(newcorrect,oldcorrect);
      for (i=0;i<datalen;i++) {
	newdata[i] = olddata[i];
	newindexes[i] = oldindexes[i];
      }
      delete olddata;
      delete oldindexes;
      delete oldcorrect;
      data = newdata;
      indexes = newindexes;
      correct = newcorrect;
      datasize = 2*datasize;
#ifdef DEBUG
      cout << "###resizing data to "<<2*datasize<<"...."<<endl;
#endif
    }
    if (strlen(line)) {
      sscanf(line,"%d %s %s %c %c",&indexes[datalen],foo,foo,&correct[datalen],&resa);
      if (resa!='n') data[datalen] = 1;
      else data[datalen] = 0;    
      datalen++;
    }
    }
  correct[datalen] = '\0';
  infs.close();
#ifdef DEBUG
  cout << "### data (length = "<<datalen<<") : "<<endl;
  for (i=0;i<datalen;i++) 
    if (data[i]>0) cout << "c";
    else cout << "n";
  cout << endl << "###" <<endl;
#endif
  cout << "\tread "<<datalen<<" items"<<endl;

  cout << "Starting predictions..."<<endl;

  /*
    The output is in the form usable by the Committee structures previosly designed, namely:
 
    <line> <NameA> <NameB> <correct label> <1st result> <1st distance> <1st proto> <2nd result> <2nd distance> <2nd proto>               
  */

#ifdef DEBUG
  cout << "### correct results:"<<endl<<correct<<endl<<"###"<<endl;
#endif 
  
  ofstream outfs;
  char outname[1024];
  sprintf(outname,"c%d-%d%s",evalrange,allowed,argv[1]);
  outfs.open(outname);
  
  double results;
  double threshold = 1-((double) allowed)/((double) evalrange);

#ifdef DEBUG
  cout << "### threshold is "<<threshold<<endl;
  cout << "### prediction results:"<<endl;
  cout.precision(2);
#endif DEBUG

  int astart=0, astop = datalen-1;
  for (i=0;i<datalen;i++) {
    astart = i-evalrange/2;
    if (astart<0) astart=0;
    astop = i+evalrange/2;
    if (astop>datalen) astop = datalen;
    results = 0;
    for (j=astart;j<astop;j++) 
      results = results + ((double) data[j]);
#ifdef FULLDEBUG
    cout << "## results = "<<results<<", used evalrange = "<<(astop-astart)<<flush;
#endif 
    results = results/( (double) (astop-astart));
#ifdef FULLDEBUG
    cout << " => results = "<<results<<endl;
#endif 
    outfs << indexes[i] << " foo foo " << correct[i] << " ";
    if (results<threshold) {
      outfs << "n 0 0 c 0 0"<<endl;
#ifdef DEBUG
#ifndef FULLDEBUG
      cout << "n" <<flush;
#endif
#endif 
    } else {
      outfs << "c 0 0 n 0 0"<<endl;
#ifdef DEBUG
      cout << "c" <<flush;
#endif 
    }
  }

  outfs << endl;
#ifdef DEBUG
  cout << endl << "###"<<endl;
#endif
  
  outfs.close();
  cout << "Done! Results are in "<<outname<<endl;
}

